<?php
# stats.php - Statistics
#
# Written by
#  Francisco Burzi
#  Patrik Wallstrm <pawal@blipp.com>
# Rewritten by
#  Aron Bostrm <aron@linux.se>
#
# This file is part of Gnuheter.
# See the file README for copyright notice.
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
#  02111-1307  USA.
#
# $Id: stats.php,v 1.2 2002/06/04 12:42:24 pawal Exp $

/* inkluderar ndvndiga filer. counter_lib anvnds bara fr att visa nuvarande beskarens OS och lsare. Kan tas bort nr betatestning r klar. */
include('mainfile.php');
include('header.php');
include_once("counter_lib.php");

/* Total r det vrde den gamla statistiken hade nr den tas/togs ur bruk.*/
$total = 314;

/* stat_open_table r en funktion so ppnar en ruta med svart ram och vit botten som endast finns p statistik-sidan. 
 Denna funktion borde knske ersttas av ngot bttre, och mer anpassningsbart.*/
function stat_open_table() { ?>
<table cellspacing="0" cellpadding="2" border="0" bgcolor="#000000"><tr><td colspan="2">
<table cellspacing="0" cellpadding="3" border="0" bgcolor="#ffffff">
<?
}

/* stat_close_table stnger en ruta med statistik i.*/
function stat_close_table() {
    echo "</table></td></tr></table>\n";
}

/* funktionen rita($namn,$antal,$totalt,$bild) ritar upp en post i statistiken fr Webblsare eller Operativsystem.
 $namn r den den text som ska visas, $bild r den bild som ska visas, "" anvnds om man inte vill ha bild.
 $totalt r totala antalet sidtrffar, anvnds fr att berkna hur stor andel som aktuell post utgr. Parametern br vara satt till $hits.
 $antal r antalet trffar som aktuell post har ftt.*/
function rita($namn,$antal,$totalt,$bild)
{
	$ut="<tr><td>";
	if ($bild!="")
		$ut.="<img src=\"images/stats/$bild\" border=\"0\" alt=\"\">&nbsp;";
	$ut.="$namn: </td><td><img src=\"images/leftbar.png\" height=14 width=7 alt=\"\">";
	$ut.="<img src=\"images/mainbar.png\" alt=\"\" height=14 width=".substr(200*$antal/$totalt,0,5).">";
	$ut.="<img src=\"images/rightbar.png\" height=14 width=7 alt=\"\"> ".substr(100*$antal/$totalt,0,5)." % ($antal)</td></tr>\n";
	echo $ut;
}

/* Fljande kod plockar ut information frn databasen och placerar den i variabler. 
 Varje post i kolumnen var i tabellen counter_ny blir en variabel med exakt samma namn, 
 och med samma vrde som den radens count-vrde.*/
$dkn = mysql_query("SELECT var, count FROM counter_ny ORDER BY count DESC");
if (!$dkn) { echo mysql_errno(). ": ".mysql_error(). "<br>";	exit(); }
while(list($var, $count) = mysql_fetch_row($dkn)) {
	$a = $var;
	$$a = $count;
}

/* Information till beskaren om vilket OS och vilken lsare den har. Statistik ver totala antalet sidtrffar.
 Denna del anvnds mest fr buggtestningsperioden.*/
$total+=$hits;
echo "<div align=\"center\">
		<table cellspacing=\"0\" cellpadding=\"2\" border=\"0\" bgcolor=\"#000000\"><tr><td colspan=\"2\">
		<table cellspacing=\"0\" cellpadding=\"3\" border=\"0\" bgcolor=\"#ffffff\"><tr><td>
		Vi har ftt <b>$total</b> trffar frn och med $startdate<br>
		Vi har ftt in <b>$hits</b> trffar sedan vi nollstllde statistiken.<br>
		Du anvnder webblsare: <br>'".valla("$HTTP_USER_AGENT")."'<br>
		P operativsystemet: <br>'".op_sys("$HTTP_USER_AGENT")."'<br>
		Med anvndaridentifieringen: <br>'".getenv("HTTP_USER_AGENT")."'.<br>
		Om detta inte stmmer var vnlig kontakta
		<A HREF=\"mailto:gnuheter-dev@mail.freesoftware.fsf.org\">utvecklarna</a>.</td></tr></table></td></tr></table>
		<br><br></div>";

/* visar statistik ver webblsarna. */
echo "<div align=\"center\">";
stat_open_table();
echo "<font color=\"#ffffff\"><div align=\"center\"><b>Webblsare</b></div>\n";
rita("MSIE",$MSIE,$hits,"explorer.png");
rita("Netscape 6+",$NS6,$hits,"netscape.png");
rita("Netscape 4-",$NS4,$hits,"netscape4.png");
rita("Mozilla",$Mozilla,$hits,"mozilla.png");
rita("Galeon",$Galeon,$hits,"galeon.png");
rita("K-Meleon",$KMeleon,$hits,"kmeleon.sourceforge.net.png");
rita("Konqueror",$Konqueror,$hits,"konqueror.png");
rita("Opera",$Opera,$hits,"opera.png");
rita("OmniWeb",$OmniWeb,$hits,"");
rita("Dillo",$Dillo,$hits,"");
rita("Mosaic",$Mosaic,$hits,"");
rita("Lynx",$Lynx,$hits,"lynx.png");
rita("Links",$Links,$hits,"");
rita("w3m",$w3m,$hits,"");
rita("Emacs/W3",$EmacsW3,$hits,"");
rita("Wget",$Wget,$hits,"");
rita("PDA/Mobiltelefoner",$PDALasare,$hits,"");
rita("Skmotorer",$Bot,$hits,"altavista.png");
rita("Validator",$Validator,$hits,"");
rita("Oknda eller vriga",$OvrigaLasare,$hits,"question.png");
echo "</font>";
stat_close_table();

echo "</div><br><br><div align=\"center\">";

/* Visar statistik ver os-en.*/
stat_open_table();
echo "<font color=\"#ffffff\"><div align=\"center\"><b>Operativsystem</b></div></font>\n";
rita("Windows",$Windows,$hits,"windows.png");
rita("Linux",$Linux,$hits,"linux.png");
rita("Macintosh",$Mac,$hits,"mac.png");
rita("MacOS X",$MacOSX,$hits,"");
rita("FreeBSD",$FreeBSD,$hits,"bsd.png");
rita("OpenBSD",$OpenBSD,$hits,"bsd.png");
rita("NetBSD",$NetBSD,$hits,"bsd.png");
rita("SunOS",$SunOS,$hits,"sun.png");
rita("IRIX",$IRIX,$hits,"irix.png");
rita("BeOS",$BeOS,$hits,"be.png");
rita("OS/2",$OS2,$hits,"os2.png");
rita("AIX",$AIX,$hits,"aix.png");
rita("Amiga",$Amiga,$hits,"");
rita("Atari",$Atari,$hits,"");
rita("AtheOS",$AtheOS,$hits,"");
rita("QNX",$QNX,$hits,"");
rita("HP-UX",$HPUX,$hits,"");
rita("Tru64 Unix",$Tru64,$hits,"");
rita("PDA/Mobiltelefoner",$PDAOS,$hits,"");
rita("Oknda eller vriga",$OvrigaOS,$hits,"question.png");
echo "</font>";
stat_close_table();
echo "</div><br><br><div align=\"center\">";

/* vrig information som ska visas hmtas hr.*/
$result = mysql_query("SELECT COUNT(*) FROM users");
list ($unum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM authors");
list ($anum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM stories");
list ($snum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM comments");
list ($cnum) = mysql_fetch_row($result);
/* $result = mysql_query("SELECT COUNT(*) FROM sections");
 list ($secnum) = mysql_fetch_row($result);
 $result = mysql_query("SELECT COUNT(*) FROM seccont");
 list ($secanum) = mysql_fetch_row($result); */
$result = mysql_query("SELECT COUNT(*) FROM queue");
list ($subnum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM topics");
list ($tnum) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM links_links");
list ($links) = mysql_fetch_row($result);
	$result = mysql_query("SELECT COUNT(*) FROM links_categories");
list ($cat1) = mysql_fetch_row($result);
$result = mysql_query("SELECT COUNT(*) FROM links_subcategories");
list ($cat2) = mysql_fetch_row($result);
$cat = $cat1+$cat2;

/* vrig information visas hr. */
stat_open_table();
echo "<font color=\"#ffffff\"><div align=\"center\"><b>Diverse statistik</b></div></font>\n";
echo "<tr><td><img src=\"images/stats/users.png\" border=\"0\">&nbsp;Registrerade anvndare: </td><td><b>$unum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/authors.png\" border=\"0\">&nbsp;Aktiva skribenter: </td><td><b>$anum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/news.png\" border=\"0\">&nbsp;Publicerade artiklar: </td><td><b>$snum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/topics.png\" border=\"0\">&nbsp;Aktiva mnen: </td><td><b>$tnum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/comments.png\" border=\"0\">&nbsp;Postade kommentarer: </td><td><b>$cnum</b></td></tr>\n";
/*echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Specialavdelningar: </td><td><b>$secnum</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/articles.png\" border=\"0\">&nbsp;Artiklar i avdelningar: </td><td><b>$secanum</b></td></tr>\n";*/
echo "<tr><td><img src=\"images/stats/topics.png\" border=\"0\">&nbsp;Lnkar i lnkdatabasen: </td><td><b>$links</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Kategorier i lnkdatabasen: </td><td><b>$cat</b></td></tr>\n";
echo "<tr><td><img src=\"images/stats/waiting.png\" border=\"0\">&nbsp;Nyheter i publiceringskn: </td><td><b>$subnum</b></td></tr>\n";
/*echo "<tr><td><img src=\"images/stats/sections.png\" border=\"0\">&nbsp;Version av PHP-Nuke: </td><td><b>$Version_Num</b></td></tr>\n";*/
html_page_foot();
echo "<br><br></div>";

include('footer.php');

?>
